Unit AM16C_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure AM16C(var A :Array of Complex; var B :Array of Complex;
                var C :Array of Complex; N :Integer);

implementation

procedure AM16C(var A :Array of Complex; var B :Array of Complex;
                var C :Array of Complex; N :Integer);
var
I,J,K,L :Integer;
R :Complex;
label
_1,_2,_3,_4;
begin
L := 0;
for I:=1 to N do
 begin
  R := Cmplx(0.0,0.0);
  if ( I = 1 ) 
   then goto _2;
  J := I-1;
  for K:=1 to J do
   begin
    L := L+1;
_1:
    R := AddC(R,MulC(A[L-1],B[K-1]));
   end;
_2:
  L := L+1;
  J := L;
  for K:=I to N do
   begin
    R := AddC(R,MulC(Conjg(A[J-1]),B[K-1]));
_3:
    J := J+K;
   end;
_4:
  C[I-1] := R;
 end;
end;

end.
